import pandas as pd
from dash import Dash, Input, Output, dcc, html
import plotly.graph_objects as go
import plotly.express as px

data_o = (
    pd.read_csv("inventario.csv")
)


Visitas_e = 4
Etapas_e = 3
Comidas_E1_e = 42
Comidas_E2_e = 9
Comidas_E3_e = 9
#Comidas_totales_e = Comidas_E1_e + Comidas_E2_e + Comidas_E3_e
Comidas_totales_e = 42
Glucometro_e = 14
Total_pacientes = len(data_o.index)
data = data_o.query("incluido == 1")
Total_incluidos = len(data)
scat = px.scatter(data, x="Days_glucose", y="Selectedfoods",size="medibles")
external_stylesheets = [
    {
        "href": (
            "https://fonts.googleapis.com/css2?"
            "family=Lato:wght@400;700&display=swap"
        ),
        "rel": "stylesheet",
    },
]
app = Dash(__name__, external_stylesheets=external_stylesheets)
app.title = "Nutridmex. Inventario de datos"

app.layout = html.Div(
    children=[
        html.Div(
            children=[
                html.P(children="🥑", className="header-emoji"),
                html.H1(
                    children="Inventario de datos", className="header-title"
                ),
                html.P(
                    children=(
                         str(Total_pacientes) +  " participantes. "
                    ),
                    className="header-description",
                ),
                html.P(
                    children=(
                         str(Total_incluidos) +  " están incluidos en el análisis. "
                    ),
                    className="header-description",
                ),

            ],
            className="header",
        ),
        html.Div(
            children=[
                html.H1("Avance en recolección", className="header-title2"),
                html.Div(
                    children=[
                
                        html.Div(children="Etapa", className="menu-title"),
                        dcc.Dropdown(
                            id="etapaSel",
                            options=[
                                {"label":1, "value":1},
                                {"label":2, "value":2},
                                {"label":3, "value":3},
                                #{"label":"Global", "value":99}
                            ],
                            # options=[
                            #     {
                            #         "label": etapa,
                            #         "value": etapa,
                            #     }
                            #     for etapa in [1,2,3]
                            # ],
                            value=1,
                            clearable=False,
                            searchable=False,
                            className="dropdown",
                        ),
                    ],
                ),
            ],
        className="wrapper"
        ),
        html.Div(children=[
            html.Div(children=[
                "Comidas",
                dcc.Slider(
                    id="min_comidas",
                    min=1,
                    max=Comidas_totales_e,
                    value=Comidas_totales_e,
                    marks={1:"1",12:"15", 21:"21",30:"30",42:"42", Comidas_totales_e:str(Comidas_totales_e)}
                ),
                "Dias con Glucómetro",
                dcc.Slider(
                    id="min_glucosa",
                    min=1,
                    max=Glucometro_e,
                    value=Glucometro_e,
                    marks={1:"1", 7:"7", 14:"14", 28:"28", 42:"+42"}
                    ),
                "Dias con reloj",
                dcc.Slider(
                    id="min_reloj",
                    min=1,
                    max=Glucometro_e,
                    value=Glucometro_e,
                    marks={1:"1", 7:"7", 14:"14", 28:"28", 42:"+42"}
                    ),
                "Microbiota",
                dcc.Slider(
                    id="min_microbiota",
                    min=1,
                    max=Visitas_e,
                    value=Visitas_e,
                    marks={1:"1", 2:"2", 3:"3", 4:"4"}
                    ),
                "Visitas",
                dcc.Slider(
                    id="min_visitas",
                    min=1,
                    max=Visitas_e,
                    value=Visitas_e,
                    marks={1:"1", 2:"2", 3:"3", 4:"4"}
                    ),
                
            ]
            ),
            html.Div(children=[ 
            dcc.Graph(id="multi-chart")],
                     )
        ],style={'display': 'flex', 'flexDirection': 'row'},

                 className="wrapper"),
        html.Div(
            children=[
                html.H1("Detalle por participante", className="header-title2"),
                html.Div(children=[
                    html.Div(
                        children=[
                            html.Div(
                                children=[
                                    html.Div(children="Etapa", className="menu-title"),
                                    dcc.Dropdown(
                                        id="etapaDet",
                                        options=[
                                            {"label":1, "value":1},
                                            {"label":2, "value":2},
                                            {"label":3, "value":3},
                                            {"label":"No-Clas.", "value":99}
                                        ],
                                        value=1,
                                        clearable=False,
                                        searchable=False,
                                        className="dropdown",
                                    ),
                                ], className="wrapper"
                            ),
                            html.Div(children=[
                                html.Div(children="Medida", className="menu-title"),
                                dcc.Dropdown(
                                    id="medidaDet",
                                    options=[
                                        {"label":"Comidas", "value":1},
                                        {"label":"Glucómetro", "value":2},
                                        {"label":"Reloj", "value":3},
                                        {"label":"Visitas", "value":4},                                                                    
                                    ],
                                    value=1,
                                    clearable=False,
                                    searchable=False,
                                    className="dropdown",
                                ), 
                            ], className="wrapper", 
                            ),

                        ], style={"display":"flex", "flexDirection": "row"},
                    ),
                    

                ],
                ),
                dcc.Graph(id="detalle_figura"),
                # dcc.Graph(
                #     figure=scat),

                ], 
            className="wrapper"
            ),
        html.Div(
            children=[
                html.H1("Detalle de visitas", className="header-title2"),
                html.P("..en construcción..", style={"color":"red", "font-style":"italic"}),
                dcc.Graph(id="multi-visitas")],
            className="wrapper",
        ),
        html.Div(
            children=[
                html.H1("Comidas Analizables", className="header-title2"),
                html.P("..en construcción..", style={"color":"red", "font-style":"italic"}),                
                html.Div(
                    children=[
                        html.Div(children="Etapa", className="menu-title"),
                        dcc.Dropdown(
                            id="mesurableEt",
                            options=[
                                {"label":"1", "value":1},
                                {"label":"2", "value":2},
                                {"label":"3", "value":3},
                                {"label":"No-Clas.", "value":4},
                                {"label":"Total", "value":5},                 
                            ],
                            value=1,
                            clearable=False,
                            searchable=False,
                            className="dropdown",
                        ), 
                        
                        
                    ], className="wrapper"
                ),
                dcc.Graph(id="mesurables")                
            ], className="wrapper"
        )


    ]
)


@app.callback(
    Output("multi-chart", "figure"),
    Output("detalle_figura", "figure"),
    Output("multi-visitas", "figure"),
    Output("mesurables", "figure"),                
    Input("etapaSel", "value"),
    Input("min_comidas", "value"),
    Input("min_glucosa", "value"),
    Input("min_reloj", "value"),    
    Input("min_microbiota", "value"),
    Input("min_visitas", "value"),
    Input("medidaDet", "value"),
    Input("etapaDet", "value"),
    Input("mesurableEt", "value"),            

)
def update_charts(etapaSel,min_comidas, min_glucosa,  min_reloj, min_microbiota, min_visitas, medidaDet, etapaDet, mesurableEt):
    total_data = len(data.index)
    gauges = {
            'shape': "bullet",
            'axis': {'range': [None, 100]},
            'steps': [
                {'range': [0, 25], 'color': "lightcyan"},
                {'range': [25, 50], 'color': "lightblue"},                
                {'range': [50, 75], 'color': "skyblue"},
                {'range': [75, 100], 'color': "steelblue"}],            
            'bar': {'color': "blue"},
        }
    numbers = { 'suffix':'%', 'valueformat':'d'}
    modes = "number+gauge"

    comidas_data = pd.DataFrame()
    glucosa_data = pd.DataFrame()
    relojes_data =  pd.DataFrame()
    microbiota_data = pd.DataFrame()
    fismet_data = pd.DataFrame()
    qs_data = pd.DataFrame()
    visitas_data = pd.DataFrame()
    
    
    if etapaSel == 1:
        visitas_data = data.loc[data["visita1"] != "0"]
        microbiota_data = data.loc[data["MV1"] != 0]
        glucosa_data = data.query("glucosa_e1 >= @min_glucosa")
        comidas_data = data.query("Comidas_e1 >= @min_comidas")
        reloj_data = data.query("pasos_e1 >= @min_reloj")                
    if etapaSel == 2:
        visitas_data = data.loc[data["visita2"] != "0"]
        microbiota_data = data.loc[data["MV2"] != 0]
        glucosa_data = data.query("glucosa_e2 >= @min_glucosa")
        comidas_data = data.query("Comidas_e2 >= @min_comidas")
        reloj_data = data.query("pasos_e2 >= @min_reloj")                        
    if etapaSel == 3:
        visitas_data = data.loc[data["visita3"] != "0"]
        microbiota_data = data.loc[data["MV3"] != 0]
        glucosa_data = data.query("glucosa_e3 >= @min_glucosa")        
        comidas_data = data.query("Comidas_e3 >= @min_comidas")        
        reloj_data = data.query("pasos_e3 >= @min_reloj")                
    if etapaSel == 99:
        comidas_data = data.query("Selectedfoods >= @min_comidas")
        glucosa_data = data.query("Days_glucose >= @min_glucosa")
        reloj_data = data.query("pasos_e3 >= @min_reloj")                
        microbiota_data = data.query("MT >= @min_microbiota")
        visitas_data = data.query("Nvisitas >= @min_visitas") 

    
    multi = go.Figure()



    multi.add_trace(go.Indicator(
        value = 100 * len(comidas_data.index) / Total_incluidos,
        domain = {'x': [0.25, 1], 'y': [0.90, 1]},
        title = {'text': "Comidas"},
        mode = modes,
        number = numbers,
        gauge = gauges,
    ))


    multi.add_trace(go.Indicator(
        value = 100 * len(glucosa_data.index) / Total_incluidos,
        domain = {'x': [0.25, 1], 'y': [0.8, 0.9]},
        title = {'text': "Glucómetro"},
        mode = modes,
        number = numbers,
        gauge = gauges
    ))

 
    
    multi.add_trace(go.Indicator(
        value = 100 * len(reloj_data.index) / Total_incluidos,
        domain = {'x': [0.25, 1], 'y': [0.7, 0.8]},
        title = {'text': "Reloj"},
        mode = modes,
        number = numbers,
        gauge = gauges
    ))
    

    multi.add_trace(go.Indicator(
        value = 100 * len(microbiota_data.index) / Total_incluidos,
#        value = min_microbiota,
        domain = {'x': [0.25, 1], 'y': [0.6, 0.7]},
        title = {'text': "Microbiota"},
        mode = modes,
        number = numbers,
        gauge = gauges
    ))


    multi.add_trace(go.Indicator(
        value = 100 * len(visitas_data.index) / Total_incluidos,
        domain = {'x': [0.25, 1], 'y':[0.5, 0.6]},
        title = {'text': "Visitas"},
        mode = modes,
        number = numbers,
        gauge = gauges
    ))    

    if etapaDet == 99:
        etapaDet = "out"
    else:
        etapaDet = "e" + str(etapaDet)    
    if medidaDet == 1:
        medCadena = "Comidas_"
        title = "Comidas"
    if medidaDet == 2:
        medCadena = "glucosa_"
        title = "Glucómetro"
    if medidaDet == 3:
        medCadena = "pasos_"
        title = "Reloj"
    if medidaDet == 4:
        medCadena = "Nvisitas"
        title = "Visitas"
        etapaDet = ""


    medCadena = medCadena + etapaDet
    detalle_figura = {
        "data": [
            {
                "x": data["nutrid"],
                "y": data[medCadena],
                "type": "bar",
            }
        ],
        "layout": {
            "title": {"text": title + " Etapa " + str(etapaDet)}
        }
    }

    multiV = go.Figure()



    multiV.add_trace(go.Indicator(
        value = 100 * len(comidas_data.index) / Total_incluidos,
        domain = {'x': [0.25, 1], 'y': [0.90, 1]},
        title = {'text': "Antropometría"},
        mode = modes,
        number = numbers,
        gauge = gauges,
    ))

    multiV.add_trace(go.Indicator(
        value = 100 * len(comidas_data.index) / Total_incluidos,
        domain = {'x': [0.25, 1], 'y': [0.80, 0.9]},
        title = {'text': "QS"},
        mode = modes,
        number = numbers,
        gauge = gauges,
    ))

    multiV.add_trace(go.Indicator(
        value = 100 * len(comidas_data.index) / Total_incluidos,
        domain = {'x': [0.25, 1], 'y': [0.7, 0.8]},
        title = {'text': "Hormonales"},
        mode = modes,
        number = numbers,
        gauge = gauges,
    ))

    multiV.add_trace(go.Indicator(
        value = 100 * len(comidas_data.index) / Total_incluidos,
        domain = {'x': [0.25, 1], 'y': [0.6, 0.7]},
        title = {'text': "C.Corporal"},
        mode = modes,
        number = numbers,
        gauge = gauges,
    ))

    multiV.add_trace(go.Indicator(
        value = 100 * len(comidas_data.index) / Total_incluidos,
        domain = {'x': [0.25, 1], 'y': [0.5, 0.6]},
        title = {'text': "Cuestionarios"},
        mode = modes,
        number = numbers,
        gauge = gauges,
    ))    

    multiV.add_trace(go.Indicator(
        value = 100 * len(comidas_data.index) / Total_incluidos,
        domain = {'x': [0.25, 1], 'y': [0.4, 0.5]},
        title = {'text': "AUCs"},
        mode = modes,
        number = numbers,
        gauge = gauges,
    ))    

    por_pasos = 1
    por_rcard = 1
    if mesurableEt < 4:
        columna = "medibles_e" + str(mesurableEt)
        por_glucosa = data[columna].sum()
    if mesurableEt == 4:
        por_glucosa = data["medibles_out"].sum()
    if mesurableEt == 5:
        por_glucosa = data["medibles_e1"].sum() + \
                      data["medibles_e2"].sum() + \
                      data["medibles_e3"].sum() + \
                      data["medibles_out"].sum()
    datos_mesurables = [ por_glucosa, por_pasos, por_rcard]
    mesurables = {
        "data": [
            {
                "x": ["Glucosa", "Pasos", "RCard"],
                "y": datos_mesurables,
                "type": "bar",
            }
        ],
        "layout": {
            "title": {"text": "Comidas Analizables"}
        }
    }
    
    return   multi, detalle_figura, multiV, mesurables


if __name__ == "__main__":
    app.run_server(debug=True, port=8051)
